Bug 1306353 - (libunity) Review Request: libunity - Library for integrating with Unity and Plasma
Review Request: libunity - Library for integrating with Unity and Plasma
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Christian Dersch
Fedora Extras Quality Assurance
:
Depends On:
Blocks: plasma5
  Show dependency treegraph
 
Reported: 2016-02-10 11:18 EST by Rex Dieter
Modified: 2016-07-18 16:53 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-12 11:05:00 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
lupinix: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Rex Dieter 2016-02-10 11:18:15 EST
Spec URL: https://rdieter.fedorapeople.org/rpms/libunity/libunity.spec
SRPM URL: https://rdieter.fedorapeople.org/rpms/libunity/libunity-7.1.4-1.fc23.src.rpm
Description: Library for integrating with Unity
Fedora Account System Username: rdieter


Being packaged primarily to provide extra features/support for plasma5 per
http://blog.broulik.de/2016/01/on-being-more-convenient/
Comment 1 Upstream Release Monitoring 2016-02-10 11:33:35 EST
rdieter's scratch build of libunity-7.1.4-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12929997
Comment 2 Kevin Kofler 2016-02-10 14:37:29 EST
Shouldn't the description say something like "Library for integrating with Unity and Plasma"?
Comment 3 Neal Gompa 2016-02-11 00:50:19 EST
I did a once-over of your package and noticed a few things:

* Where's the Python 3 module? libunity does support Python 3, and the Ubuntu package provides it as part of the "gir1.2-unity-5.0" package.

* Please do not use unversioned Python macros (like %{__python}, %{python_sitearch}, etc.). Please use the versioned ones so that unexpected things don't happen in the future (like the target of the unversioned ones switching on you).

* When trying to do a soversion lock, please don't use ".so.X*", as that glob will potentially allow bad things to happen (if the soversion jumps a ton, we might not notice). Please instead split into two: ".so.X" and ".so.X.*". That properly locks the soversion down.

* Please check to be sure that you aren't repeating the work of file triggers in releases of Fedora that support and use them. I believe glib-compile-schemas falls under one of these, per this message[0]. Starting with Fedora 24, this action will be handled automatically, so please guard these out for F24+.

* Please somehow indicate in the Version or Release field that this is the version shipped with Ubuntu Wily. This will be extremely important as this library will likely be upgraded as Canonical upgrades it in Ubuntu before each release (Xenial coming up soon!).



[0]: https://lists.fedoraproject.org/pipermail/desktop/2015-August/012685.html
Comment 4 Rex Dieter 2016-02-11 13:42:36 EST
Spec URL: https://rdieter.fedorapeople.org/rpms/libunity/libunity.spec
SRPM URL: https://rdieter.fedorapeople.org/rpms/libunity/libunity-7.1.4-2.20151002.fc23.src.rpm

%changelog
* Thu Feb 11 2016 Rex Dieter <rdieter@fedoraproject.org> 7.1.4-2.20151002
- update summary/description
- python3 support
- make glib-compile-schemas scriptlet conditional (< f24 only)
- include snapshot date in Release:


* I don't agree with the soversion lock recommendation here, as I'm fairly confident the library soname will always be a single digit, so there's little to no risk of not properly tracking the library ABI with the current scheme.
Comment 5 Neal Gompa 2016-02-12 23:52:15 EST
This is a bit of a nitpick, but unless you plan on supporting < EL7, you could use "%make_build" in place of "make %{?_smp_mflags}" and "%make_install" in place of "make install DESTDIR=%{buildroot}". 

Also, why are you deleting *.so symlink files from %{_libdir}/libunity? That's not something we ordinarily do (though we do quite often delete the *.la files).
Comment 6 Rex Dieter 2016-02-13 08:11:37 EST
Yes, no need for nitpicking... let's try to prioritize fixing review blockers first. :)
Comment 7 Rex Dieter 2016-02-13 08:21:08 EST
The library under %{_libdir}/libunity was put there only because it is private, so it should never get linked  (and need the .so symlink).  That said, it's presence is mostly harmless anyway.
Comment 8 Rex Dieter 2016-04-15 14:39:45 EDT
Fyi, Copr for initial testing:
https://copr.fedorainfracloud.org/coprs/rdieter/libunity/
Comment 9 Christian Dersch 2016-07-05 11:33:16 EDT
Taken, review will follow soon :)
Comment 10 Christian Dersch 2016-07-05 12:01:10 EDT
Looks fine => Approved!

f-r gave a message about obsolete autotools macros (see below), you could ask upstream about this.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "LGPL (v3.0)", "GPL (v3)", "Unknown or
     generated". 29 files have unknown license. Detailed output of
     licensecheck in /home/review/1306353-libunity/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     libunity-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools

===> See below, has to be fixed upstream

[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libunity-7.1.4-2.20151002.fc25.x86_64.rpm
          libunity-devel-7.1.4-2.20151002.fc25.x86_64.rpm
          python3-libunity-7.1.4-2.20151002.fc25.x86_64.rpm
          libunity-debuginfo-7.1.4-2.20151002.fc25.x86_64.rpm
          libunity-7.1.4-2.20151002.fc25.src.rpm
libunity.x86_64: E: non-executable-script /usr/share/unity-scopes/scope-runner-dbus.py 644 /usr/bin/python
libunity.x86_64: W: no-manual-page-for-binary libunity-tool
libunity.x86_64: W: no-manual-page-for-binary unity-scope-loader
libunity.x86_64: W: one-line-command-in-%postun /sbin/ldconfig
libunity-devel.x86_64: W: only-non-binary-in-usr-lib
libunity-devel.x86_64: W: no-documentation
python3-libunity.x86_64: W: only-non-binary-in-usr-lib
python3-libunity.x86_64: W: no-documentation
libunity.src:56: W: mixed-use-of-spaces-and-tabs (spaces: line 56, tab: line 2)
5 packages and 0 specfiles checked; 1 errors, 8 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libunity-debuginfo-7.1.4-2.20151002.fc25.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
libunity-debuginfo (rpmlib, GLIBC filtered):

python3-libunity (rpmlib, GLIBC filtered):
    libunity(x86-64)
    python(abi)
    python3-gobject-base

libunity (rpmlib, GLIBC filtered):
    /bin/sh
    /sbin/ldconfig
    libatk-1.0.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo-gobject.so.2()(64bit)
    libcairo.so.2()(64bit)
    libdbusmenu-glib.so.4()(64bit)
    libdee-1.0.so.4()(64bit)
    libgdk-3.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgmodule-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgthread-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libm.so.6()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    libunity-protocol-private.so.0()(64bit)
    libunity.so.9()(64bit)
    rtld(GNU_HASH)

libunity-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libunity(x86-64)
    libunity-extras.so.9()(64bit)
    libunity.so.9()(64bit)
    pkgconfig(dbusmenu-glib-0.4)
    pkgconfig(dee-1.0)
    pkgconfig(gio-2.0)
    pkgconfig(glib-2.0)
    pkgconfig(gobject-2.0)
    pkgconfig(gthread-2.0)
    pkgconfig(unity)



Provides
--------
libunity-debuginfo:
    libunity-debuginfo
    libunity-debuginfo(x86-64)

python3-libunity:
    python3-libunity
    python3-libunity(x86-64)

libunity:
    libunity
    libunity(x86-64)
    libunity-extras.so.9()(64bit)
    libunity-protocol-private.so.0()(64bit)
    libunity.so.9()(64bit)

libunity-devel:
    libunity-devel
    libunity-devel(x86-64)
    pkgconfig(unity)
    pkgconfig(unity-extras)
    pkgconfig(unity-protocol-private)



Source checksums
----------------
https://launchpad.net/ubuntu/+archive/primary/+files/libunity_7.1.4+15.10.20151002.orig.tar.gz :
  CHECKSUM(SHA256) this package     : 323e122979cda3aaf030a760f525a2d1d42602b339ba01665fd1f5291946c9e9
  CHECKSUM(SHA256) upstream package : 323e122979cda3aaf030a760f525a2d1d42602b339ba01665fd1f5291946c9e9


AutoTools: Obsoleted m4s found
------------------------------
  AM_PROG_CC_STDC found in: libunity-7.1.4+15.10.20151002/configure.ac:63
  AM_PROG_LIBTOOL found in: libunity-7.1.4+15.10.20151002/configure.ac:65
  AM_CONFIG_HEADER found in: libunity-7.1.4+15.10.20151002/configure.ac:5

===> Think about querying upstream about this


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -v -m fedora-rawhide-x86_64 -b 1306353
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 11 Rex Dieter 2016-07-05 12:32:13 EDT
Thanks!

pkgdb request submitted
Comment 12 Gwyn Ciesla 2016-07-05 13:32:21 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/libunity
Comment 13 Fedora Update System 2016-07-06 11:10:57 EDT
libunity-7.1.4-2.20151002.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-18e76d06b7
Comment 14 Fedora Update System 2016-07-06 11:11:41 EDT
libunity-7.1.4-2.20151002.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-d19835776f
Comment 15 Fedora Update System 2016-07-09 23:54:07 EDT
libunity-7.1.4-3.20151002.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-d19835776f
Comment 16 Fedora Update System 2016-07-10 12:00:47 EDT
libunity-7.1.4-3.20151002.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-18e76d06b7
Comment 17 Fedora Update System 2016-07-12 11:04:58 EDT
libunity-7.1.4-3.20151002.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 18 Fedora Update System 2016-07-18 16:53:24 EDT
libunity-7.1.4-3.20151002.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.